<?php
namespace Contabilidade\Logic\Contabilizacao;

use \Setforms2\Runtime\Helper\Procedure;
use \Setforms2\Runtime\Helper\Procedure\Param;

class Contabilizacao
{
	/** Gera Contabil DFE */
    public static function geraCtbDfeContab($cdfilial, $nrlanctonf){
        try{
            $procedure = new Procedure('CTB_DFE_CONTAB');
			$procedure->addParam(new Param('P_CDFILIAL'  , Param::PARAM_INPUT , $cdfilial  , Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCTONF', Param::PARAM_INPUT , $nrlanctonf, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCCTB' , Param::PARAM_OUTPUT, null       , Param::PARAM_TYPE_INT, 12));
            $nrlancctb = $procedure->call();
			return $nrlancctb['P_NRLANCCTB'];
        }catch(\Exception $e){
            throw $e;
        }
    }
	
	/** Gera Contabil DFS */
	public static function geraCtbDfsContab($cdfilial, $nrlanctonf){
        try{
            $procedure = new Procedure('CTB_DFS_CONTAB');
            $procedure->addParam(new Param('P_CDFILIAL'  , Param::PARAM_INPUT , $cdfilial  , Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCTONF', Param::PARAM_INPUT , $nrlanctonf, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCCTB' , Param::PARAM_OUTPUT, null       , Param::PARAM_TYPE_INT, 12));
            $nrlancctb = $procedure->call();
			return $nrlancctb['P_NRLANCCTB'];
        }catch(\Exception $e){
            throw $e;
        }
    }
}
