/* Sistemas Integrados TEKNISA
  Integrao - SAGA

 Nome: Rotina de exportao das mercadorias (produtos)

Criao:
28/03/2013 - Fabrcio Marcelo

@C:\web_545\sql\end_conv\oracle\clientes\ris\6400_RISSTPO_Exporta_Produto_Saga.SQL
*/

CREATE OR REPLACE PROCEDURE EXPORTA_PRODUTO_SAGA
AS
   V_NRCONTADOR     INT;
   V_NMNIVEL        VARCHAR2(20);
   V_VRFATPRODEST   FLOAT;
BEGIN
   V_NRCONTADOR := 0;

   /* Novos registros */
   FOR C_PRODUTO IN (SELECT P.CDPRODUTO, P.CDARVPROD, TRIM(P.NMPRODUTO) NMPRODUTO, P.CDCLASFISC,
                            C.CDGRUPREGARMAZ, TO_NUMBER(C.CDMOTIVOBLOQ) AS CDMOTIVOBLOQ, TO_NUMBER(VRPERMARMAZEM) AS VRPERMARMAZEM,
                            TO_NUMBER(VRPRAZMAXREC) AS VRPRAZMAXREC, TO_NUMBER(VRJANELAFIFO) AS VRJANELAFIFO,
                            TO_NUMBER(VRJANFIFOTRANS) AS VRJANFIFOTRANS, TO_NUMBER(VRPRAZVALIDADE) AS VRPRAZVALIDADE,
                            TO_NUMBER(VRSHELFLIFE) AS VRSHELFLIFE, TO_NUMBER(VRTEMPMEDESTOQ) AS VRTEMPMEDESTOQ,
                            TO_NUMBER(VRTEMPMEDEXPED) AS VRTEMPMEDEXPED, TO_NUMBER(VRTEMPMEDRECEB) AS VRTEMPMEDRECEB,
                            TO_NUMBER(VRPRAZMAXDEV) AS VRPRAZMAXDEV
                       FROM PRODUTO P, CARACPRODSAGA C
                      WHERE P.CDNVPRODUTO = (SELECT MAX(CDNVPRODUTO) FROM PRODUTO)
                        AND P.CDPRODUTO = P.CDPRODESTO
                        AND P.IDPRODATIVPR = 'S'
                        AND P.DTEXPPRODSAGA IS NULL
                        AND P.CDPRODUTO = C.CDPRODUTO

                      UNION ALL

                     SELECT P.CDPRODUTO, P.CDARVPROD, TRIM(P.NMPRODUTO) NMPRODUTO, P.CDCLASFISC,
                            C.CDGRUPREGARMAZ, TO_NUMBER(C.CDMOTIVOBLOQ) AS CDMOTIVOBLOQ, TO_NUMBER(VRPERMARMAZEM) AS VRPERMARMAZEM,
                            TO_NUMBER(VRPRAZMAXREC) AS VRPRAZMAXREC, TO_NUMBER(VRJANELAFIFO) AS VRJANELAFIFO,
                            TO_NUMBER(VRJANFIFOTRANS) AS VRJANFIFOTRANS, TO_NUMBER(VRPRAZVALIDADE) AS VRPRAZVALIDADE,
                            TO_NUMBER(VRSHELFLIFE) AS VRSHELFLIFE, TO_NUMBER(VRTEMPMEDESTOQ) AS VRTEMPMEDESTOQ,
                            TO_NUMBER(VRTEMPMEDEXPED) AS VRTEMPMEDEXPED, TO_NUMBER(VRTEMPMEDRECEB) AS VRTEMPMEDRECEB,
                            TO_NUMBER(VRPRAZMAXDEV) AS VRPRAZMAXDEV
                       FROM PRODUTO P, CARACPRODSAGA C
                      WHERE P.CDNVPRODUTO = (SELECT MAX(CDNVPRODUTO) FROM PRODUTO)
                        AND P.CDPRODUTO = P.CDPRODESTO
                        AND P.IDPRODATIVPR = 'S'
                        AND ((P.DTULTATUPROD >= P.DTEXPPRODSAGA) OR (C.DTULTATUCARACP >= P.DTEXPPRODSAGA))
                        AND P.CDPRODUTO = C.CDPRODUTO

                      ORDER BY CDARVPROD)
   LOOP
      V_NMNIVEL := SUBSTR(C_PRODUTO.CDARVPROD,1,03);

      /* Produto de Estoque */
      INSERT INTO INT_CADMER
         (CODMER, CODGRPMER, NOMABRMER, DESMER, CODALGSEL, CODGRPCARLGT,
          CODGRPREGARM, CODMTVBLQ, CODTIPEMB, CODTIPMER, NRODIAPRMARM, VALDIAPRZMAXREC,
          VALJANFIF, VALJANFIFTRF, VALPRZVALMER, VALSHFLFE, VALTEMMEDETQ, VALTEMMEDEXP,
          VALTEMMEDREC, BOLEMIETQ, BOLFRCMER, BOLGERUND, BOLOTMARZ, BOLPESOBR,
          BOLUTLMTPSKU, BOLVLDDAT, FLAPRC, DSCERR, DATULTPRC, CODGRPTOL,
          VALDIAPRZMAXRECDEV, CODNCM, VLRUNDVND)
      VALUES
         (C_PRODUTO.CDARVPROD, V_NMNIVEL, SUBSTR(C_PRODUTO.NMPRODUTO, 1, 40), C_PRODUTO.NMPRODUTO, 1, NULL,
          C_PRODUTO.CDGRUPREGARMAZ, C_PRODUTO.CDMOTIVOBLOQ,1,1, C_PRODUTO.VRPERMARMAZEM, C_PRODUTO.VRPRAZMAXREC,
          C_PRODUTO.VRJANELAFIFO, C_PRODUTO.VRJANFIFOTRANS, C_PRODUTO.VRPRAZVALIDADE, C_PRODUTO.VRSHELFLIFE, C_PRODUTO.VRTEMPMEDESTOQ, C_PRODUTO.VRTEMPMEDEXPED,
          C_PRODUTO.VRTEMPMEDRECEB, 0,0,1,1,0,
          0,1,'0',NULL, NULL,'0',
          C_PRODUTO.VRPRAZMAXDEV, C_PRODUTO.CDCLASFISC,1);


      /* Relacionamento do produto com a filial */
      FOR C_FILIAL IN (SELECT DISTINCT CDFILIALSAGA FROM PARAMFILIAL
                        WHERE NOT CDFILIALSAGA IS NULL)
      LOOP
         INSERT INTO INT_RELMERSTE
            (CODMER, CODSTE, FLAPRC, DSCERR, DATULTPRC)
         VALUES
            (C_PRODUTO.CDARVPROD, C_FILIAL.CDFILIALSAGA, '0', NULL, NULL);

         V_NRCONTADOR := V_NRCONTADOR + 1;
      END LOOP;

      V_VRFATPRODEST := 0;

      /* Embalagens do Produto */
      FOR C_TPROD IN (SELECT P.CDPRODUTO, P.VRFATOCONV, P.SGUNIDADE, U.DSUNIDADE,
                             DECODE(P.CDPRODUTO, P.CDPRODESTO, 1, 2) AS CODTIPEMB,
                             DECODE(P.CDPRODUTO, P.CDPRODESTO, 1, 0) AS BOLSKUPDR,
                             C.VRLARGURA, C.VRALTURA, C.VRPROFUNDIDADE, C.VRPESO,
                             C.VRPESOLIQ, C.VRVOLUME, C.VRPALPRODALT, C.VRPALPRODCOM,
                             C.VRPALPRODLAR
                        FROM PRODUTO P, UNIDMEDIDA U, CARACPRODSAGA C
                       WHERE P.CDPRODESTO = C_PRODUTO.CDPRODUTO
                         AND P.SGUNIDADE = U.SGUNIDADE
                         AND P.IDPRODATIVPR = 'S'
                         AND C.CDPRODUTO = P.CDPRODUTO
                       ORDER BY P.VRFATOCONV)
      LOOP
         /* Embalagens do Produto */
         IF V_VRFATPRODEST <> C_TPROD.VRFATOCONV THEN
            INSERT INTO INT_CADSKU
               (CODMER, VALEMBSKU, NOMABRSKU, DESSKU, CODGRPCARLGT, CODTIPEMB,
                VALDIMX, VALDIMY, VALDIMZ, VALPES, VALPESLIQ, VALVOL,
                VALCAPMAXEMP, FLAPRC, DSCERR, BOLSKUPDR, DATULTPRC)
            VALUES
               (C_PRODUTO.CDARVPROD, C_TPROD.VRFATOCONV, C_TPROD.SGUNIDADE||TO_CHAR(C_TPROD.VRFATOCONV), C_TPROD.DSUNIDADE, NULL, C_TPROD.CODTIPEMB,
                C_TPROD.VRLARGURA, C_TPROD.VRALTURA, C_TPROD.VRPROFUNDIDADE, C_TPROD.VRPESO, C_TPROD.VRPESOLIQ, C_TPROD.VRVOLUME,
                1, '0', NULL, C_TPROD.BOLSKUPDR, NULL);

            FOR C_BARRA IN (SELECT NVL(CDBARPRODUTO, CDARVPROD) AS CDBARRAPROD
                              FROM PRODUTO
                             WHERE CDPRODUTO = C_TPROD.CDPRODUTO
                             UNION ALL
                            SELECT CDBARRAPROD
                              FROM CDBARRAPROD
                             WHERE CDPRODUTO = C_TPROD.CDPRODUTO)
            LOOP
               /* Cdigo de barras do Produto */
               INSERT INTO INT_RELSKUBRR
                  (CODMER, VALEMBSKU, CODBRR, FLAPRC, CODPSSPRP, DSCERR, DATULTPRC)
               VALUES
                  (C_PRODUTO.CDARVPROD, C_TPROD.VRFATOCONV, C_BARRA.CDBARRAPROD, '0', NULL, NULL, NULL);


               V_NRCONTADOR := V_NRCONTADOR + 1;
            END LOOP;

            /* Configuraes para Paletizao */
            FOR C_PALET IN (SELECT '201' AS CODDSP, 1 AS BOLPDR
                              FROM DUAL
                             UNION ALL
                            SELECT '202' AS CODDSP, 0 AS BOLPDR
                              FROM DUAL)
            LOOP
               INSERT INTO INT_RELSKUDSP
                  (CODMER, VALEMBSKU, CODDSP, CODPSS, BOLPDR,
                   VALALT, VALCAPMAXEMP, VALQTDSKUALT, VALQTDSKUCPR, VALQTDSKULRG,
                   FLAPRC, DSCERR, DATULTPRC)
               VALUES
                  (C_PRODUTO.CDARVPROD, C_TPROD.VRFATOCONV, C_PALET.CODDSP, NULL, C_PALET.BOLPDR,
                   1, 1, C_TPROD.VRPALPRODALT, C_TPROD.VRPALPRODCOM, C_TPROD.VRPALPRODLAR,
                   '0', NULL, NULL);


               V_NRCONTADOR := V_NRCONTADOR + 1;
            END LOOP;
            V_NRCONTADOR := V_NRCONTADOR + 1;
         END IF;

         V_VRFATPRODEST := C_TPROD.VRFATOCONV;
      END LOOP;

      UPDATE PRODUTO
         SET DTEXPPRODSAGA = SYSDATE
       WHERE CDPRODUTO = C_PRODUTO.CDPRODUTO;

      IF V_NRCONTADOR = 500 THEN
         V_NRCONTADOR := 0;
         COMMIT;
      END IF;
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXPORTA_PRODUTO_SAGA','5.45.XXX'); END;
/
